



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LibSVM使用指南</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LibSVM使用指南</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 23:49:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>LibSVM使用指南</h1>
<p><strong>一、&nbsp;&nbsp;&nbsp;&nbsp; </strong><strong>SVM</strong><strong>简介</strong></p>
<p>在进行下面的内容时我们认为你已经具备了数据挖掘的基础知识。</p>
<p>SVM是新近出现的强大的数据挖掘工具，它在文本分类、手写文字识别、图像分类、生物序列分析等实际应用中表现出非常好的性能。SVM属于监督学习算法，样本以属性向量的形式提供，所以输入空间是Rn的子集。</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/103496/2011092418233495.png" /></p>
<p>如图1所示，SVM的目标是找到两个间距尽可能大的边界平面来把样本本点分开，以&rdquo;最小化泛化误差&ldquo;，即对新的样本点进行分类预测时，出错的几率最小。落在边界平面上的点称为支持向量。Vapnik证明如果可以找到一个较小的支持向量集，就可以保证得到很好的泛化能力----也就是说支持向量的个数越少越好。</p>
<p>数据点通常在输入空间是线性不可分的，我们把它映射到更高维的特征空间，使其线性可分----这里的映射函数我们称之为核函数。特征空间的超平面对应输入空间的一个非线性的分离曲面，因此称为非线性分离器。</p>
<p>SVM分类器的输出是u=w*x+b，w是分类平面的法矢，x是输入向量，b是常量，u代表分类。即SVM的目的就是计算出w和b。最大化margin（两个分类平面之间的距离）等价于求下面的二次优化问题：</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/103496/2011092418312014.png" /></p>
<p>对于非线性分类器就要把x映射到特征空间,同时考虑误差的存在（即有些样本点会越过分类边界），上述优化问题变为：</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/103496/2011092418315024.png" /></p>
<p>从输入空间是映射到特征空间的函数称为核函数，LibSVM中使用的默认核函数是RBF（径向基函数radial basis function）</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/103496/2011092418330898.png" /></p>
<p>这样一来就有两个参数需要用户指定：gamma。实际上在LibSVM中用户需要给出一个gamma的区间，LibSVM采用交叉验证cross-validation accuracy的方法确定分类效果最好的gamma。</p>
<p>举个例子说明什么是交叉验证，假如把训练样本集拆成三组，然后先拿&nbsp;train model&nbsp;predict 3&nbsp;以得到正确率； 再来拿&nbsp;3 train&nbsp;predict 1&nbsp;，最后&nbsp;1,3 train&nbsp;predict 2&nbsp;，最后取预测精度最高的那组c和gamma。</p>
<p>有时属于不同分类的样本数是不平衡的，所以有人提出（二次优化）的目标函数应该为：</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/103496/2011092418344741.png" /></p>
<p>LibSVM中允许用户指定权重值</p>
<p>对于文本分类采用最简单的线性分类器即可，因为输入的文档向量矩阵高度稀疏，可以认为不需要映射到特征空间，在输入空间就线性可分, 这样我们就不需要使用核函数了----然而我的实践证明这个结论并不总是正确的。</p>
<p>二、<strong>LibSVM</strong><strong>的安装</strong></p>
<ol><li>Linux上下载<a href="http://www.csie.ntu.edu.tw/~cjlin/cgi-bin/libsvm.cgi?+http://www.csie.ntu.edu.tw/~cjlin/libsvm+tar.gz" rel="external nofollow noreferrer">tar.gz</a>包</li>
<li>解压后就可直接使用java版的了</li></ol>
<p>但要求电脑上装有1.5版本以上的java，并且设置好了$classpath全局变量。</p>
<p>三、<strong>了解</strong><strong>libsvm</strong><strong>工具包</strong></p>
<p>LIBSVM是台湾大学林智仁(Lin Chih-Jen)教授等2001年开发设计的一个简单, 易于使用和快速有效的SVM模式识别与回归的软件包, 他不但提供了编译好的可在Windows系列系统的执行文件, 还提供了源代码, 方便改进, 修改以及在其它操作系统上应用; 该软件对SVM所涉及的参数调节相对比较少, 提供了很多的默认参数, 利用这些默认参数可以解决很多问题; 并提供了交互检验(Cross Validation)的功能. 该软件包可在http://www.csie.ntu.edu.tw/~cjlin/ 免费获得. 该软件可以解决C-SVM, &nu;-SVM, &epsilon;-SVR和&nu;-SVR等问题, 包括基于一对一算法的多类模式识别问题.</p>
<p>这套库可以从http://www.csie.ntu.edu.tw/~cjlin/libsvm/index.html免费获得, 目前已经发展到3.12版(2012.4.1更新).下载.tar.gz格式的版本, Windows下也可以直接解压, 主要有6个文件夹和一些源码文件.</p>
<p>Java: 主要是应用于java平台;</p>
<p>matlab: windows下64位matlab平台;</p>
<p>python: 是用来参数优选的工具, 稍后介绍;</p>
<p>svm-toy: 一个可视化的工具, 用来展示训练数据和分类界面, 里面是源码, 其编译后的程序在windows文件夹下;</p>
<p>tools: 主要包含四个python文件, 用来数据集抽样(subset), 参数优选（grid）, 集成测试(easy), 数据检查(checkdata);</p>
<p>windows: 包含libSVM四个exe程序包, 我们所用的库就是他们.</p>
<p>文件夹里面还有个heart_scale, 是一个样本文件, 可以用记事本打开, 用来测试用的.</p>
<p>其他.h和.cpp文件都是程序的源码, 可以编译出相应的.exe文件. 其中, 最重要的是svm.h和svm.cpp文件, svm-predict.c, svm-scale.c和svm-train.c（还有一个svm-toy.c在svm-toy文件夹中）都是调用的这个文件中的接口函数, 编译后就是windows下相应的四个exe程序. 另外, 里面的README跟FAQ也是很好的文件, 对于初学者如果W文较好的话, 可以看一下.</p>
<p>对于仅仅使用libsvm库的人来说, windows下的4个exe包已经足够了, 如果是为了做深入研究, 可以按照自己的思路文件夹中的.cpp和.c文件, 然后编译验证）</p>
<p><strong>四、下面开始测试</strong><strong>libsvm</strong><strong>工具包</strong></p>
<p>1). 把LibSVM包解压到相应的目录(因为我只需要里面windows文件夹中的exe程序包, 我们也可以只把windows文件夹拷到相应的目录), 比如C:\jacoxu\test\libsvm-3.12</p>
<p>2). 在电脑&rdquo;开始&rdquo;的&rdquo;运行&rdquo;中输入cmd, 进入DOS环境. 定位到C:\jacoxu\test\libsvm-3.12下, 具体命令如下:</p>
<p><img referrerpolicy="no-referrer"src="http://ww2.sinaimg.cn/mw690/697b070fjw1dvifw3kxkvj.jpg" /></p>
<p>3). 进行libsvm训练, 输入命令:</p>
<p>svm-train ../heart_scale train.model</p>
<p>heart_scale: 是目录下的已经存在的样本文件, 要换成自己的文件, 只需改成自己的文件名就可以了;</p>
<p>train.model: 是创建的结果文件, 保存了训练后的结果:</p>
<p><img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/mw690/697b070fjw1dvifw7my97j.jpg" /></p>
<p>其中, #iter 为迭代次数;</p>
<p>nu 是选择的核函数类型的参数;</p>
<p>obj 为SVM文件转换为的二次规划求解得到的最小值;</p>
<p>rho 为判决函数的偏置项<em>b;</em></p>
<p>nSV 为标准支持向量个数(0&lt;a[i]&lt;c);</p>
<p>nBSV 为边界上的支持向量个数(a[i]=c);</p>
<p>Total nSV为支持向量总个数(对于两类来说, 因为只有一个分类模型Total nSV = nSV</p>
<p>但是对于多类, 这个是各个分类模型的nSV之和).</p>
<p>在目录下, 还可以看到产生了一个train.model文件, 可以用记事本打开, 记录了训练后的结果.</p>
<div>
<pre class="prettyprint linenums">svm_type c_svc             //所选择的svm类型, 默认为c_svc<br />
kernel_type rbf             //训练采用的核函数类型, 此处为RBF核<br />
gamma 0.0769231          //RBF核的参数&gamma;<br />
nr_class 2                 //类别数, 此处为两分类问题<br />
total_sv 132               //支持向量总个数<br />
rho 0.424462              //判决函数的偏置项b<br />
label 1 -1                 //原始文件中的类别标识<br />
nr_sv 64 68               //每个类的支持向量机的个数<br />
SV                     //以下为各个类的权系数及相应的支持向量<br />
1 1:0.166667 2:1 3:-0.333333 &hellip; 10:-0.903226 11:-1 12:-1 13:1<br />
0.5104832128985164 1:0.125 2:1 3:0.333333 &hellip; 10:-0.806452 12:-0.333333 13:0.5<br />
   &hellip;&hellip;&hellip;<br />
-1 1:-0.375 2:1 3:-0.333333&hellip;. 10:-1 11:-1 12:-1 13:1<br />
-1 1:0.166667 2:1 3:1 &hellip;. 10:-0.870968 12:-1 13:0.5  </pre>
</div>
<p>这里注意, 第二行出现的权系数为小数(0.5104832128985164)是因为这个点属于非边界上的支持向量, 即: (0&lt;a[i]&lt;c).</p>
<p>其他的两个(svm-predict, svm-scale)的使用过程类似.</p>
<p><strong>五、LibSVM的使用</strong></p>
<p>我们只讲Linux下Java版的使用，在有的VM上，java版的libsvm运行速度可逼近C++版的运行速度。</p>
<p>cd &nbsp; /path/to/libsvm-3.1/java</p>
<p>java -classpath libsvm.jar svm_scale &lt;arguments&gt;</p>
<p>java -classpath libsvm.jar svm_train &lt;arguments&gt;</p>
<p>java -classpath libsvm.jar svm_predict &lt;arguments&gt;</p>
<p>java -classpath libsvm.jar svm_toy</p>
<p><strong>1）LibSVM要求处理的文件数据都满足如下格式：</strong></p>
<p>rlabel1 index1:value1 index2:value2 &hellip;...</p>
<p>rlabel2 index1:value1 index2:value2 &hellip;...</p>
<p>下面的脚本是我用于转换成LibSVM要求的文件格式用的，作个备份：</p>
<div>
<pre class="prettyprint linenums">#!/usr/bin/perl<br />
$file="/home/orisun/libsvm/testvec";<br />
$file2="/home/orisun/libsvm/testvec_svmfmt";<br />
#$file="/home/orisun/libsvm/trainvec";<br />
#$file2="/home/orisun/libsvm/trainvec_svmfmt";<br />
open VFILE,"$file";<br />
open FFILE,"&gt;$file2";<br />
while(&lt;VFILE&gt;){<br />
    chomp;<br />
    my @cont=split;<br />
    $no=$cont[0];<br />
    my $rlable;<br />
    #$rlable=int($no%1000);<br />
    if($no eq "C39"){<br />
        $rlable=0;<br />
    }elsif($no eq "C31"){<br />
        $rlable=1;<br />
    }elsif($no eq "C32"){<br />
        $rlable=2;<br />
    }elsif($no eq "C38"){<br />
        $rlable=3;<br />
    }elsif($no eq "C34"){<br />
        $rlable=4;<br />
    }elsif($no eq "C19"){<br />
        $rlable=5;<br />
    }<br />
    print FFILE "$rlable\t";<br />
    for($i=1;$i&lt;@cont;$i++){<br />
        if($cont[$i]!=0){<br />
            print FFILE "$i:$cont[$i]\t";<br />
        }<br />
    }<br />
    print FFILE "\n";<br />
}</pre>
</div>
<p>libsvm在存储中存储数据时默认采用的是float，而不是double。当你原始数据精度要求很高时这确实是个问题。</p>
<p>rlabel表示分类，为一个数字。</p>
<p>Index从1开始递增，表示输入向量的序号。</p>
<p>value是输入向量相应维度上的值，就是要训练的数据, 从分类的角度来说就是特征值, 数据之间用空格隔开，如果value为0,该项可以不写。下面是一个示例文件：</p>
<p>0 1：3.2 3：1.6</p>
<p>1 1：1.5 2：4.2 3：0.5</p>
<p>0 1：5.1 2：1.6 3：2.0</p>
<p>1 2：5.4</p>
<p><strong>2）svm_scale用于把输入向量按列进行规范化（或曰缩放）。</strong></p>
<p>svmscale是用来对原始样本进行缩放的, 范围可以自己定, 一般是[0,1]或[-1,1]. 缩放的目的主要是</p>
<p>（1） 防止某个特征过大或过小, 从而在训练中起的作用不平衡;</p>
<p>（2） 为了计算速度. 因为在核计算中, 会用到内积运算或exp运算, 不平衡的数据可能造成计算困难.</p>
<p>用法：</p>
<p>svmscale [-l lower] [-u upper]</p>
<p>[-y y_lower y_upper]</p>
<p>[-s save_filename]</p>
<p>[-r restore_filename] filename</p>
<p>选项:</p>
<p>-l lower : x scaling lower limit (default -1) &nbsp;设定数据下限; lower: 设定的数据下限值, 缺省为-1</p>
<p>-u upper : x scaling upper limit (default +1) &nbsp;设定数据上限; upper: 设定的数据上限值, 缺省为1</p>
<p>-y y_lower y_upper : y scaling limits (default: no y scaling) &nbsp;是否对目标值同时进行缩放; y_lower为下限值, y_upper为上限值;</p>
<p>-s save_filename : save scaling parameters to save_filename &nbsp;表示将缩放的规则保存为文件save_filename;</p>
<p>-r restore_filename : restore scaling parameters from restore_filename &nbsp;&nbsp;表示将按照已经存在的规则文件restore_filename进行缩放;</p>
<p>filename: 待缩放的数据文件, 文件格式按照libsvm格式.</p>
<p>默认情况下, 只需要输入要缩放的文件名就可以了: 比如(已经存在的文件为test.txt)</p>
<p>svmscale test.txt</p>
<p>这时, test.txt中的数据已经变成[-1,1]之间的数据了. 但是, 这样原来的数据就被覆盖了, 为了让规划好的数据另存为其他的文件, 我们用一dos的重定向符&gt;来另存为(假设为out.txt):</p>
<p>svmscale test.txt &gt; out.txt</p>
<p>运行后, 我们就可以看到目录下多了一个out.txt文件, 那就是规范后的数据. 假如, 我们想设定数据范围[0,1], 并把规则保存为test.range文件:</p>
<p>svmscale &ndash;l 0 &ndash;u 1 &ndash;s test.range test.txt &gt; out.txt</p>
<p>这时, 目录下又多了一个test.range文件, 可以用记事本打开, 下次就可以用-r test.range来载入了.</p>
<p>举个例子，比如我运行：java svm_scale -l 0 -u 1 -s range train &gt; train.scale则输入文件是train，输出文件是&nbsp;train.scale，把输入向量的各列都缩放到[0，1]的范围内，range文件中保存了相关的缩放信息。</p>
<p>Train文件原来的内容：</p>
<p>1 1:0 2:0</p>
<p>1 1:3 2:4</p>
<p>1 1:5 2:9</p>
<p>1 1:12 2:1</p>
<p>1 1:8 2:7</p>
<p>0 1:9 2:8</p>
<p>0 1:6 2:12</p>
<p>0 1:10 2:8</p>
<p>0 1:8 2:5</p>
<p>0 1:14 2:8</p>
<p>range文件自动生成：</p>
<p>x</p>
<p>0.000000000000000 1.000000000000000</p>
<p>1 0.000000000000000 14.00000000000000</p>
<p>2 0.000000000000000 12.00000000000000</p>
<p>train.scale文件自动生成：</p>
<p>1.0</p>
<p>1.0 1:0.21428571428571427 2:0.3333333333333333</p>
<p>1.0 1:0.35714285714285715 2:0.75</p>
<p>1.0 1:0.8571428571428571 2:0.08333333333333333</p>
<p>1.0 1:0.5714285714285714 2:0.5833333333333334</p>
<p>0.0 1:0.6428571428571429 2:0.6666666666666666</p>
<p>0.0 1:0.42857142857142855 2:1.0</p>
<p>0.0 1:0.7142857142857143 2:0.6666666666666666</p>
<p>0.0 1:0.5714285714285714 2:0.4166666666666667</p>
<p>0.0 1:1.0 2:0.6666666666666666</p>
<p>然后我再运行：java svm_scale -r range test &gt; test.scale意思是说从range文件中读取缩放信息运用于test文件，输出test.scale文件。</p>
<p><strong>3）svmtrain</strong><strong>的用法</strong></p>
<p>svmtrain我们在前面已经接触过, 他主要实现对训练数据集的训练, 并可以获得SVM模型.</p>
<p>用法: svmtrain [options] training_set_file [model_file]</p>
<p>其中, options为操作参数, 可用的选项即表示的涵义如下所示:</p>
<p>-s 设置svm类型:</p>
<p>0 &ndash; C-SVC &nbsp;//(multi-class classification)</p>
<p>1 &ndash; v-SVC &nbsp;//((multi-class classification)</p>
<p>2 &ndash; one-class-SVM &nbsp;//one-class SVM</p>
<p>3 &ndash; &epsilon;-SVR &nbsp;//(regression)</p>
<p>4 &ndash; n &ndash; SVR&nbsp;&nbsp;//(regression)</p>
<p>-t kernel_type : set type of kernel function (default 2) &nbsp;&nbsp;设置核函数类型, 默认值为2</p>
<p>0 &mdash; linear &nbsp; 线性核:&nbsp;&mu;&lsquo;&lowast;&nu;</p>
<p>1 &mdash; polynomial &nbsp; 多项式核: &nbsp; &nbsp;(&gamma;&lowast;&mu;&lsquo;&lowast;&nu;+coef0)degree</p>
<p>2 &mdash; radia basis function &nbsp; RBF核:&nbsp;exp(&ndash;&gamma;&lowast;∥&mu;&minus;&nu;∥2)</p>
<p>3 &mdash; sigmoid &nbsp; sigmoid 核:&nbsp;tanh(&gamma;&lowast;&mu;&lsquo;&lowast;&nu;+coef0)</p>
<p>　　　 4&mdash;precomputed kernel (kernel values in training_set_file)</p>
<p>-d degree: set degree in kernel function (default 3) &nbsp;&nbsp;核函数中的degree设置(针对多项式核函数)(默认3);</p>
<p>-g r(gama): set gamma in kernel function (default 1/num_features) &nbsp;&nbsp;核函数中的gamma函数设置(针对多项式/rbf/sigmoid核函数)(默认1/ k);</p>
<p>-r coef0:in kernel function (default 0) &nbsp;&nbsp; 核函数中的coef0设置(针对多项式/sigmoid核函数)((默认0);</p>
<p>-c cost: set the parameter C of C-SVC, epsilon-SVR, and nu-SVR (default 1) &nbsp;&nbsp;设置C-SVC, e -SVR和v-SVR的参数(损失函数)(默认1);</p>
<p>-n nu: set the parameter nu of nu-SVC, one-class SVM, and nu-SVR (default 0.5) &nbsp;&nbsp;设置v-SVC, 一类SVM和v- SVR的参数(默认0.5);</p>
<p>-p p: set the epsilon in loss function of epsilon-SVR (default 0.1) &nbsp;&nbsp;设置e -SVR 中损失函数p的值(默认0.1);</p>
<p>-m cachesize: set cache memory size in MB (default 100) &nbsp;&nbsp;设置cache内存大小, 以MB为单位(默认40);</p>
<p>-e eps: set tolerance of termination criterion (default 0.001) &nbsp;&nbsp;设置允许的终止判据(默认0.001);</p>
<p>-h shrinking: whether to use the shrinking heuristics, 0 or 1 (default 1) &nbsp;&nbsp;是否使用启发式, 0或1(默认1);</p>
<p>-wi weight: set the parameter C of class i to weight*C, for C-SVC (default 1) &nbsp;&nbsp;设置第几类的参数C为weight*C (C-SVC中的C) (默认1);</p>
<p>-v n: n-fold cross validation mode &nbsp;&nbsp;n-fold交互检验模式, n为fold的个数, 必须大于等于2;</p>
<p>-b probability_estimates : whether to train a SVC or SVR model for probability estimates, 0 or 1 (default 0) &nbsp;&nbsp;概率估计: 是否计算SVC或SVR的概率估计, 可选值0或1, 默认0;</p>
<p>-q : quiet mode (no outputs)</p>
<p>model_file: 可选项, 为要保存的结果文件, 称为模型文件, 以便在预测时使用.</p>
<p>其中-g选项中的k是指输入数据中的属性数. option -v 随机地将数据剖分为n部分并计算交互检验准确度和均方根误差. 以上这些参数设置可以按照SVM的类型和核函数所支持的参数进行任意组合, 如果设置的参数在函数或SVM类型中没有也不会产生影响, 程序不会接受该参数; 如果应有的参数设置不正确, 参数将采用默认值.</p>
<p>training_set_file是要进行训练的数据集; model_file是训练结束后产生的模型文件, 文件中包括支持向量样本数, 支持向量样本以及lagrange系数等必须的参数; 该参数如果不设置将采用默认的文件名, 也可以设置成自己惯用的文件名.</p>
<p>默认情况下, 只需要给函数提供一个样本文件名就可以了, 但为了能保存结果, 还是要提供一个结果文件名, 比如: test.model, 则命令为:</p>
<p>svmtrain test.txt test.model</p>
<p>接着上例，向量规范化后我们train一下训练样本，以生成支持向量。</p>
<p>运行：java svm_train -s 0 -c 5 -t 2 -g 0.5 -e 0.01 train.scale</p>
<p>会生成train.scale.model文件，内容如下：</p>
<p>svm_type c_svc</p>
<p>kernel_type rbf</p>
<p>gamma 0.5</p>
<p>nr_class 2</p>
<p>total_sv 9</p>
<p>rho -0.5061570424019811</p>
<p>label 1 0</p>
<p>nr_sv 4 5</p>
<p>SV</p>
<p>2.7686973549711875 1:0.21428571428571427 2:0.3333333333333333</p>
<p>5.0 1:0.35714285714285715 2:0.75</p>
<p>5.0 1:0.8571428571428571 2:0.08333333333333333</p>
<p>5.0 1:0.5714285714285714 2:0.5833333333333334</p>
<p>-5.0 1:0.6428571428571429 2:0.6666666666666666</p>
<p>-2.4351637665059895 1:0.42857142857142855 2:1.0</p>
<p>-5.0 1:0.7142857142857143 2:0.6666666666666666</p>
<p>-5.0 1:0.5714285714285714 2:0.4166666666666667</p>
<p>-0.3335335884651968 1:1.0 2:0.6666666666666666</p>
<p>nr_class代表训练样本集有几类，rho是判决函数的常数项b，nr_sv是各个类中落在边界上的向量个数，SV下面枚举了所有的支持向量，每个支持向量前面都有一个数字，<strong>代表什么我现在也不清楚。</strong></p>
<p>当train C-SVM时会有类似下面的输出：</p>
<p>optimization finished, #iter = 219</p>
<p>nu = 0.431030</p>
<p>obj = -100.877286, rho = 0.424632</p>
<p>nSV = 132, nBSV = 107</p>
<p>Total nSV = 132</p>
<p>obj是对SSVM问题的优化目标函数的值。rho是决策函数中的常数项b。nSV是支持向量的个数，nBSV是边界支持向量的个数(i.e., alpha_i = C)。</p>
<p>如果&ldquo;自由支持向量&rdquo;个数很多，很可能是因为过拟合了。如果输入数据的attribute在一个很大的范围内分布，最好scale一下。</p>
<p>采用时默认的核函数RBF是比较好的，if RBF is used with model selection, then there is no need to consider the linear kernel.</p>
<p>如果预测的准确率太低，如何提高一下？使用python目录下的grid.py进行模型选择以找到比较好的参数。</p>
<p><strong>grid.py是一种用于RBF核函数的C-SVM分类的参数选择程序</strong>。用户只需给定参数的一个范围，grid.py采用交叉验证的方法计算每种参数组合的准确度来找到最好的参数。</p>
<p>Usage: grid.py [-log2c begin,end,step] [-log2g begin,end,step] [-v fold]</p>
<p>[-svmtrain pathname] [-gnuplot pathname] [-out pathname] [-png pathname]</p>
<p>[additional parameters for svm-train] dataset</p>
<p>The program conducts v-fold cross validation using parameter C (and gamma)= 2^begin, 2^(begin+step), ..., 2^end.</p>
<p>首先sudo apt-get install gnuplot</p>
<p>然后编译C++版本的LibSVM，生成svm-train二进制可执行文件。</p>
<p>cd &nbsp;/path/to/libsvm-3.1</p>
<p>make</p>
<p>举个例子就都明白了：python grid.py -log2c -5,5,1 -log2g -4,0,1 -v 5 -svmtrain /home/orisun/develop/libsvm-3.1/svm-train -m 500 traincev_svmfmt_part1</p>
<p>-m 500是使用svm_train时可以使用的参数。</p>
<p>最后输出两个文件：dataset.png绘出了交叉验证精度的轮廓图，dataset.out对于每一组log2(c)和log2(gamma)对应的CV精度值。</p>
<p>如果训练时间过长，你可能需要：</p>
<p>1.指定更大有cache size。（-m）</p>
<p>2.使用更宽松的stopping tolerance。（-e）</p>
<p>当使用一个很大有-e时，你可能需要检查一下-h 0 (no shrinking) or -h 1 (shrinking)哪个更快。</p>
<p>3.如果上面的方法还不行就需要裁剪训练集。使用tools目录下的subset.py来随机获得训练集的一个子集。</p>
<p>Usage: subset.py [options] dataset number [output1] [output2]</p>
<p>This script selects a subset of the given data set.</p>
<p>options:</p>
<p>-s method : method of selection (default 0)</p>
<p>0 -- stratified selection (classification only)</p>
<p>1 -- random selection</p>
<p>output1 : the subset (optional)</p>
<p>output2 : the rest of data (optional)</p>
<p>If output1 is omitted, the subset will be printed on the screen.</p>
<p>当迭代次数很高时使用shrinking是有帮助的，而当使用一个很大的-e时，迭代次数会减少，最好把shrinking关掉。</p>
<p>当指定一个很大-m时Linux会报"段错误&ldquo;，很可能是内存溢出了。对于32位的机子最大的可编址内存是4G。同时Linux系统按照3：1来划分用户空间：核空间，所以用户空间只有最大只有3G，而可动态分配的内存最大只有2G。当你使用一个接近2G的-m时内存就会耗尽。</p>
<p>解决办法：</p>
<p>1.换64位的机子。</p>
<p>2.如果你的机子支持Intel's PAE (Physical Address Extension），你可以在Linux内核中开启HIGHMEM64G选项，这样核空间和用户空间的划分就是4G:4G。</p>
<p>3.安装"tub&rdquo;软件，它可以消除动态分配内存只有2G的限制。tub可以在这里获取 http://www.bitwagon.com/tub.html。</p>
<p>在svm_train的过程中如果不想看到中间输出可以使用-q选项。</p>
<p>如果你是在编程代码中使用libsvm库，可以这样：</p>
<p>1.声明一个空的输出函数：void print_null(const char *s) {}</p>
<p>2.把它赋给libsvm库中的输出函数：svm_print_string = &amp;print_null;</p>
<p>在处理多类分类问题时，libsvm采用的是one-against-one,而不是one-against-the rest，实际上后者的性能要好，而之所以采用前者仅仅是因为它快。</p>
<p>交叉验证是为了选择更好的参数，做完交叉验证后并不会输出model文件，此时你需要re-train the whole data without the -v option。</p>
<p>如果你有多核/共享内存的计算机,libsvm还允许你采用OpenMP进行并行编程。</p>
<p>预测时如果开启-b则会耗费更长的时间，并且开启-b和提高预测的准确率并没有绝对的关系。</p>
<p><strong>4). svmpredict&nbsp;</strong><strong>的用法</strong></p>
<p>svmpredict 是根据训练获得的模型, 对数据集合进行预测.</p>
<p>用法: svmpredict [options] test_file model_file output_file</p>
<p>其中, options为操作参数, 可用的选项即表示的涵义如下所示:</p>
<p>-b probability_estimates: 是否需要进行概率估计预测, 可选值为0 或者1, 默认值为0.</p>
<p>model_file: 是由svmtrain 产生的模型文件;</p>
<p>test_file: 是要进行预测的数据文件, 格式也要符合libsvm格式,&nbsp;<strong>即使不知道</strong><strong>label</strong><strong>的值</strong><strong>,&nbsp;</strong><strong>也要任意填一个</strong>, svmpredict会在output_file中给出正确的label结果, 如果知道label的值, 就会输出正确率;</p>
<p>output_file: 是svmpredict 的输出文件, 表示预测的结果值.</p>
<p>最后可以预测分类了，运行：java svm_predict test.scale train.scale.model result</p>
<p>test.scale&nbsp;是待预测的文件，&nbsp;train.scale.model是利用训练文本集生成的model文件，最终会生成result文件，内容如下：</p>
<p>1.0</p>
<p>1.0</p>
<p>0.0</p>
<p>1.0</p>
<p>0.0</p>
<p>0.0</p>
<p>0.0</p>
<p>0.0</p>
<p>1.0</p>
<p>0.0</p>
<p>由于在&nbsp;test.scale中我已标记了正确的rlable，所以&nbsp;svm_predict还会报告正确率Accuracy = 70.0% (7/10) (classification)。在实际的分类问题中，我们当然是无法提前知道待分类文件中的rlabel中，可以任意标记一个数字，这时候还会给出Accuracy&nbsp;，不过它是毫无意义的。</p>
<p>在使用svm_toy时只支持3种颜色，最大分类数是3。如果想有更多分类，需要修改原代码svm-toy.cpp。如果直接从文件中load数据，要求向量是2维的，并且每一维都在(0,1),同时rlabel只能是1、2、3（甚至不能是1.0、2.0、3.0）。</p>
<p>下面是使用svn_toy的一个截图：</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2011/103496/2011092418393815.png" /></p>
<p>图2</p>
<p><strong>LibSVM库函数的调用</strong></p>
<div>
<p>库函数在"libsvm"包中。</p>
<p>在Java版中以下函数可以调用：</p>
<p>public class svm {</p>
<p>public static final int LIBSVM_VERSION=310;</p>
<p>public static svm_model svm_train(svm_problem prob, svm_parameter param);</p>
<p>public static void svm_cross_validation(svm_problem prob, svm_parameter param, int nr_fold, double[] target);</p>
<p>public static int svm_get_svm_type(svm_model model);</p>
<p>public static int svm_get_nr_class(svm_model model);</p>
<p>public static void svm_get_labels(svm_model model, int[] label);</p>
<p>public static double svm_get_svr_probability(svm_model model);</p>
<p>public static double svm_predict_values(svm_model model, svm_node[] x, double[] dec_values);</p>
<p>public static double svm_predict(svm_model model, svm_node[] x);</p>
<p>public static double svm_predict_probability(svm_model model, svm_node[] x, double[] prob_estimates);</p>
<p>public static void svm_save_model(String model_file_name, svm_model model) throws IOException</p>
<p>public static svm_model svm_load_model(String model_file_name) throws IOException</p>
<p>public static String svm_check_parameter(svm_problem prob, svm_parameter param);</p>
<p>public static int svm_check_probability_model(svm_model model);</p>
<p>public static void svm_set_print_string_function(svm_print_interface print_func);</p>
<p>}</p>
<p>注意在Java版中svm_node[]的最后一个元素的索引不是-1.</p>
<p>用户可以自定义自己的输出格式，通过：</p>
<p>your_print_func = new svm_print_interface()</p>
<p>{</p>
<p>public void print(String s)</p>
<p>{</p>
<p>// your own format</p>
<p>}</p>
<p>};</p>
<p>svm.svm_set_print_string_function(your_print_func);</p>
<p><strong>更为详细请见：<a href="http://blog.csdn.net/flydreamgg" rel="external nofollow noreferrer">LibSVM学习</a></strong></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8km0p59.html">linux之sed用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwrx3y9.html">关于VR边纹理材质的渲染</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1y709.html">更改Apache默认网站根目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oppzj9.html">MySQL数据库远程连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xd6wm8.html">【ZZ】超全面的设计模式总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zdv069.html">win7如何共享文件 图文教你设置win7文件共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x6mx09.html">【python】Python 3 &plus;pycharm中文支持解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1g43j9.html">数据库系统&mdash;&mdash;B&plus;树索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmoy149.html">【转】 i2c驱动调试经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjn1rx8.html">HDU--1006</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljok7k9.html">Moss列表查询，删除条目，更新条目。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk57gj8.html">SQL中创建外键约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj3yyeq.html">转： 【Java并发编程】之五：volatile变量修饰符&mdash;意料之外的问题（含代码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9501w1z8.html">python学习之路前端-JavaScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k3xg29.html">Spring Cloud 微服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwg0pk8.html">tp剩余未验证内容-7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv4vdr8.html">ODPS SQL &amp;lt&semi;for 数据定义语言 DDL&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj2en68.html">IOS &lpar;补充&rpar;触摸事件处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmlzne9.html">IntelliJ IDEA 2017版 spring-boot与Mybatis简单整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k3eklq.html">JAVA并发编程学习笔记------结构化并发应用程序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96oo5m49.html">Mysql插入数据的时候&comma;中文乱码问题的解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvv0pjq.html">ListFragment</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z11jwd9.html">Android 图片Exif信息相关的获取与修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e11j0j9.html">struts2 详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yykr3q.html">LCA模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z113vv9.html">mybatis动态SQL中的sql片段</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xxde68.html">C&num;&lowbar;微信支付V3</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mm2zxq.html">nfs服务器设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnn65z8.html">c&plus;&plus;程序编码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zzyw69.html">SqlServer扩展存储过程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
